pro batch_process, master_list=master_list


;;; to run Scanamorphos in batch mode
;;; inputs in the ascii file master_list (give its full path)
;;; for each field: journal saved in output directory = input directory

;;;;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

;;; copyright 2007-2011 H\'el\`ene Roussel
;;; roussel@iap.fr
;;; Institut d'Astrophysique de Paris - Universit\'e Pierre et Marie Curie, France

;;; download and documentation: http://www2.iap.fr/users/roussel/herschel/

;;; Scanamorphos is distributed under the terms of the GNU General Public License
;;; (http://www.gnu.org/licenses/gpl.html).

;;; introduced August 2010: version 2

;;;;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



resolve_all, /continue_on_error, /quiet


;;; parent directory of SCANAMORPHOS/:

root = ''
openr, 1, '$HOME/scanam.dir'
readf, 1, format='(A)', root
close, 1

nc = strlen(root)
if strmid(root, nc-1) ne '/' then root = root + '/'
dir_scanmap = root + 'SCANAMORPHOS/'

crs = string(13b) + string(10b)



;;; loop on fields:

narr = 3

openr, 9, master_list
repeat begin

   file_out = ''
   readf, 9, format='(A)', file_out
   file_out = strtrim(file_out, 2)
   dir_in = ''
   readf, 9, format='(A)', dir_in
   dir_in = strtrim(dir_in, 2)
   nc = strlen(dir_in)
   if strmid(dir_in, nc-1) ne '/' then dir_in = dir_in + '/'
   inst = ''
   readf, 9, format='(A)', inst
   inst = strlowcase(strtrim(inst, 2))
   if strmid(inst, 0, 1) eq '/' then inst = strmid(inst, 1)

   file_scanlist = 'scanlist_' + inst
   openw, 8, dir_scanmap + file_scanlist
   printf, 8, format='(A)', dir_in
   options = ", /batch, file_out='" + file_out + "', /" + inst

   input = ' '
   while (not eof(9) and strmid(input, 0, 1) ne '#') do begin
      readf, 9, format='(A)', input
      if strmid(input, 0, 4) eq 'stru' then printf, 8, format='(A)', input $
      else if (strmid(input, 0, 1) ne '#' and strmid(input, 0, 1) ne ';') $
         then options = options + ", " + input
   endwhile

   close, 8
   print, crs + '##############################' + crs
   print, file_out + crs
   file_log = dir_in + file_out + '.log'
   test = file_test(file_log)
   ind = 1
   if test eq 1 then repeat begin
      ind += 1
      file_log = dir_in + file_out + '_' + chain(ind) + '.log'
      test = file_test(file_log)
   endrep until test eq 0
   journal, file_log
   flag = execute("scanamorphos" + options)
   journal
   clean_log, file=file_log

endrep until eof(9)
close, 9


end
