pro set_mask_spire, mask_hipe, mask_global, nt=nt, nb=nb

;;; transforms the Hipe bit mask into a binary mask
;;; (a sample is either valid or invalid)


;;;;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

;;; copyright 2007-2011 H\'el\`ene Roussel
;;; roussel@iap.fr
;;; Institut d'Astrophysique de Paris - Universit\'e Pierre et Marie Curie, France

;;; download and documentation: http://www2.iap.fr/users/roussel/herschel/

;;; Scanamorphos is distributed under the terms of the GNU General Public License
;;; (http://www.gnu.org/licenses/gpl.html).

;;; July 2010: public release version 1

;;;;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



mask_global = intarr(nt, nb)

bit_fatal = long([4, 17])
bit_glitch = [5, 11, 13]
bit_glitch_uncorr = [6, 12, 14]

;;; fatal bits: ADC truncation not corrected
;;;             glitch detected and corrected
;;;             glitch detected during first level deglitching and corrected
;;;             glitch detected during second level deglitching and corrected
;;;             V0_flag and/or K_flag set to true: no flux conversion possible


nbit = 18L
for bit = nbit, 1L, -1L do begin
   bitmask = 2L^bit
   w = where(mask_hipe ge bitmask, cw)
   if (cw ge 1 and min(abs(bit_glitch_uncorr - bit)) gt 0) then begin
      if min(abs(bit_fatal - bit)) lt 1 then mask_global(w) = 1
      if min(abs(bit_glitch - bit)) lt 1 then begin
	 wcorr = where(mask_hipe(w) lt 2L * bitmask, cw_corr, complement=wuncorr, ncomplement=cw_uncorr)
	 if cw_corr ge 1 then mask_global(w(wcorr)) = 1
	 if cw_uncorr ge 1 then mask_hipe(w(wuncorr)) -= (2L * bitmask)
      endif
      mask_hipe(w) -= bitmask
   endif
endfor


end
