function chain, val, ndec


;;; converts value to string with given number of decimals and no surrounding blanks

;;;;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

;;; copyright 2007-2011 H\'el\`ene Roussel
;;; roussel@iap.fr
;;; Institut d'Astrophysique de Paris - Universit\'e Pierre et Marie Curie, France

;;; download and documentation: http://www2.iap.fr/users/roussel/herschel/

;;; Scanamorphos is distributed under the terms of the GNU General Public License
;;; (http://www.gnu.org/licenses/gpl.html).

;;; July 2010: public release version 1

;;;;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



if not keyword_set(ndec) then ndec = 0
n = n_elements(val)
ch_sign = strarr(n)
w = where(val lt 0., cw)
if cw ge 1 then ch_sign(w) = '-'
value = abs(val)
val_int = floor(value)
val_dec = round((value - val_int) * 10.^ndec)
w = where(val_dec eq 10.^ndec, cw)
if cw ge 1 then begin
   val_int(w) = val_int(w) + 1
   val_dec(w) = 0
endif
ch_int = strtrim(string(val_int), 2)
ch_dec = strtrim(string(val_dec), 2)
size_dec = strlen(ch_dec)
nz = ndec - size_dec
for i = 0, n - 1 do for k = 0, nz(i) - 1 do ch_dec(i) = '0' + ch_dec(i)
res = ch_sign + ch_int 
if ndec gt 0 then res = res + '.' + ch_dec
if n eq 1 then res = res(0)
return, res


end
