pro compute_diginoise, file_scalars=file_scalars, diginoise, maxnoise=maxnoise, $
                       ind_scans=ind_scans, time_1=time_1, t_proc=t_proc


;;; estimates digitization step (for PACS in debug mode; for informative purposes only)  

;;;;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

;;; copyright 2007-2011 H\'el\`ene Roussel
;;; roussel@iap.fr
;;; Institut d'Astrophysique de Paris - Universit\'e Pierre et Marie Curie, France

;;; download and documentation: http://www2.iap.fr/users/roussel/herschel/

;;; Scanamorphos is distributed under the terms of the GNU General Public License
;;; (http://www.gnu.org/licenses/gpl.html).

;;; July 2010: public release version 1

;;;;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



restore, file_scalars

restore, file_signal


diginoise = fltarr(nscans, nb) + !values.f_nan

diff = abs(signal(1:nt-1, *) - signal(0:nt-2, *))
for b = 0L, nb - 1L do for i = 0, nscans - 1 do if finite(maxnoise(i, b)) gt 0. then begin
   histo = histogram(diff(ind_scans(i):ind_scans(i+1)-2, b), locations=sb, $
      binsize=0.00001, min=0.0001, max=0.1000, /nan)
   w = where(histo ge max(histo) / 5.)
   ind = w(0)
   diginoise(i, b) = sb(ind)

   if (keyword_set(debug) and b eq bref and i eq 0) then begin
      time_2 = systime(/seconds)
      t_proc += (time_2 - time_1)
      wset, 0
      otherplot, sb, histo, psym=10, xtitle='abs(signal(it+1) - signal(it))', ytitle='N', $
         title='in red: quantization step'
      otherplot, /over, psym=4, color=10, symbsize=3., [sb(ind)], [max(histo)]
      res = dialog_message('   Continue ?   ', /center, /information, title='Pause')
      time_1 = systime(/seconds)
   endif
endif

end
