pro otherplot, x, y, psym=psym, lstyle=lstyle, over=over, xrange=xrange, yrange=yrange, $
               title=title, xtitle=xtitle, ytitle=ytitle, symbsize=symbsize, charsize=charsize, $
               color=color, zero=zero, thick=thick


;;; produces a plot with readable axes and reasonable coordinate ranges by default

;;;;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

;;; copyright 2007-2011 H\'el\`ene Roussel
;;; roussel@iap.fr
;;; Institut d'Astrophysique de Paris - Universit\'e Pierre et Marie Curie, France

;;; download and documentation: http://www2.iap.fr/users/roussel/herschel/

;;; Scanamorphos is distributed under the terms of the GNU General Public License
;;; (http://www.gnu.org/licenses/gpl.html).

;;; July 2010: public release version 1

;;;;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



if not keyword_set(psym) then psym = 0
if not keyword_set(lstyle) then lstyle = 0
if not keyword_set(xrange) then begin
   xmin = min(x)
   xmax = max(x)
   rx = xmax - xmin
   if rx eq 0. then rx = xmax
   xrange = [xmin - rx/20., xmax + rx/20.]
endif
if not keyword_set(yrange) then begin
   ymin = min(y)
   ymax = max(y)
   if keyword_set(zero) then ymin = 0.
   ry = ymax - ymin
   if ry eq 0. then ry = ymax
   if keyword_set(zero) then ydeb = 0. else ydeb = ymin - ry/20.
   yrange = [ydeb, ymax + ry/20.]
endif
if not keyword_set(title) then title = ''
if not keyword_set(xtitle) then xtitle = ''
if not keyword_set(ytitle) then ytitle = ''
if not keyword_set(symbsize) then symbsize = 1.
if not keyword_set(charsize) then charsize = 2.
if not keyword_set(color) then color = 0
if not keyword_set(thick) then thick = 2.

if not keyword_set(over) then plot, x, y, psym=psym, linestyle=lstyle, xrange=xrange, xstyle=1, $
   yrange=yrange, ystyle=1, title='!6'+title, xtitle='!6'+xtitle, ytitle='!6'+ytitle, $
   charsize=charsize, color=color, background=!d.n_colors-1, $
   thick=thick, xthick=2., ythick=2., charthick=2., symsize=symbsize $
 else oplot, x, y, psym=psym, linestyle=lstyle, color=color, thick=thick, symsize=symbsize


end
