pro stat_map, med, sig, map=map, weightmap=weightmap, noise_level=noise_level


;;; estimates an approximate background level and dispersion of an image
;;; (used to define source masks)

;;;;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

;;; copyright 2007-2011 H\'el\`ene Roussel
;;; roussel@iap.fr
;;; Institut d'Astrophysique de Paris - Universit\'e Pierre et Marie Curie, France

;;; download and documentation: http://www2.iap.fr/users/roussel/herschel/

;;; Scanamorphos is distributed under the terms of the GNU General Public License
;;; (http://www.gnu.org/licenses/gpl.html).

;;; July 2010: public release version 1

;;;;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



w = where(weightmap gt 0. and finite(map) gt 0)
binsize = min([noise_level / 3., (max(map, /nan) - min(map, /nan)) / 20.])
histo = histogram(map(w), locations=sb, binsize=binsize)
m = max(histo, ind)
w = where(histo gt m / 20.)
med = sb(w(0))
w = where(weightmap gt 0. and finite(map) gt 0 and map le sb(ind))
sig = sqrt(mean((map(w) - med)^2.))
if sig lt 10. * noise_level then for k = 0, 9 do begin
   w = where(weightmap gt 0. and map - med le 2. * sig)
   histo = histogram(map(w), locations=sb, binsize=binsize)
   m = max(histo, ind)
   med = sb(ind)
   w = where(weightmap gt 0. and map le med)
   sig = sqrt(mean((map(w) - med)^2.))
   w = where(weightmap gt 0. and abs(map - med) le 2. * sig)
   med = median(map(w))
endfor else sig = 10. * noise_level


end
